---
policy: /ce/ca/aws/ec2/instance-detailed-monitoring
logic: /ce/ca/aws/ec2/instance-detailed-monitoring/prod.logic.yaml
executionTime: 2025-04-24T23:44:29.677838137Z
rows:
  - id: test1
    match: true
    status:
      expected: DISAPPEARED
      actual: DISAPPEARED
    conditionIndex:
      expected: 99
      actual: 99
    conditionText:
      expected: isDisappeared(CA10__disappearanceTime__c)
      actual: isDisappeared(CA10__disappearanceTime__c)
    runtimeError: {}
  - id: test2
    match: true
    status:
      expected: INAPPLICABLE
      actual: INAPPLICABLE
    conditionIndex:
      expected: 199
      actual: 199
    conditionText:
      expected: extract('CA10__stateName__c') != 'running'
      actual: extract('CA10__stateName__c') != 'running'
    runtimeError: {}
  - id: test3
    match: true
    status:
      expected: INCOMPLIANT
      actual: INCOMPLIANT
    conditionIndex:
      expected: 299
      actual: 299
    conditionText:
      expected: extract('CA10__monitoringState__c') == 'disabled'
      actual: extract('CA10__monitoringState__c') == 'disabled'
    runtimeError: {}
  - id: test4
    match: true
    status:
      expected: COMPLIANT
      actual: COMPLIANT
    conditionIndex:
      expected: 399
      actual: 399
    conditionText:
      expected: extract('CA10__monitoringState__c') == 'enabled'
      actual: extract('CA10__monitoringState__c') == 'enabled'
    runtimeError: {}
usedFiles:
  - path: /ce/ca/aws/ec2/instance-detailed-monitoring/policy.yaml
    md5Hash: 47D2F034904C30660A52D7021FDF89AA
    content: "---\nnames:\n  full: AWS EC2 Instance Detailed Monitoring is not enabled\n\
      \  contextual: Instance Detailed Monitoring is not enabled\ndescription: >\n\
      \  Ensure that detailed monitoring is enabled for Amazon EC2 instances. This\
      \ \n  configuration improves the granularity of monitoring data from AWS CloudWatch,\
      \ \n  enabling 1-minute data points instead of the default 5-minute intervals.\n\
      type: \"COMPLIANCE_POLICY\"\ncategories:\n  - \"RELIABILITY\"\nframeworkMappings:\n\
      \  - \"/frameworks/cloudaware/resource-reliability/system-configuration\""
  - path: /ce/ca/aws/ec2/instance-detailed-monitoring/prod.logic.yaml
    md5Hash: 082F5842FF4E609AB7AB810CEA5046DE
    content: |
      ---
      inputType: "CA10__CaAwsInstance__c"
      importExtracts:
        - file: "/types/CA10__CaAwsInstance__c/object.extracts.yaml"
      testData:
        - file: "test-data.json"
      conditions:
        - status: "INAPPLICABLE"
          currentStateMessage: "The EC2 instance is not running."
          check:
            NOT_EQUAL:
              left:
                EXTRACT: "CA10__stateName__c"
              right:
                TEXT: "running"
        - status: "INCOMPLIANT"
          currentStateMessage: "The instance is running without detailed monitoring enabled."
          remediationMessage: "Consider enabling detailed monitoring for the instance."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__monitoringState__c"
              right:
                TEXT: "disabled"
        - status: "COMPLIANT"
          currentStateMessage: "Detailed monitoring for the instance is enabled."
          check:
            IS_EQUAL:
              left:
                EXTRACT: "CA10__monitoringState__c"
              right:
                TEXT: "enabled"
      otherwise:
        status: "UNDETERMINED"
        currentStateMessage: "Unexpected values in the field."
  - path: /types/CA10__CaAwsInstance__c/object.extracts.yaml
    md5Hash: 802FA80DBDE640AF85A69B42E51E0CCD
    content: "---\nextracts:\n# Values pending, applied. Not nullable. Can't have\
      \ no access, retrieved via ec2:DescribeInstances\n  - name: \"CA10__metadataState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__metadataState__c\"\n    \
      \    undeterminedIf:\n          isEmpty: \"Corrupted data. EC2 Instances Metadata\
      \ State cannot be empty.\"\n# Values: optional, required. Not nullable. Can't\
      \ have no access, retrieved via ec2:DescribeInstances\n  - name: \"CA10__metadataHttpTokens__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__metadataHttpTokens__c\"\n\
      \        undeterminedIf:\n          isEmpty: \"Corrupted data. EC2 Instances\
      \ Metadata Http Token cannot be empty.\"\n  - name: CA10__iamInstanceProfileArn__c\n\
      \    value:\n      FIELD: \n        path: CA10__iamInstanceProfileArn__c\n#\
      \ Nullable. Can't have no access, retrieved via ec2:DescribeInstances\n  - name:\
      \ \"CA10__publicIpAddress__c\"\n    value: \n      FIELD:\n        path: \"\
      CA10__publicIpAddress__c\"\n# Values: enabled, disabled. Not nullable. Can't\
      \ have no access, retrieved via ec2:DescribeInstances\n  - name: \"CA10__monitoringState__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__monitoringState__c\"\n  \
      \      undeterminedIf:\n          isEmpty: \"Corrupted data. EC2 Instances Detailed\
      \ Monitoring State cannot be empty.\"\n# Values: pending | running | shutting-down\
      \ | terminated | stopping | stopped. Not nullable.\n  - name: \"CA10__stateName__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__stateName__c\"\n        undeterminedIf:\n\
      \          noAccessDelegate:\n            path: \"CA10__stateName__c\"\n   \
      \         currentStateMessage: \"Unable to determine EC2 Instances State Name.\
      \ Possible permission issue with ec2:DescribeInstanceStatus\"\n# Number of Days.\
      \ Nullable. Can't have no access, retrieved via ec2:DescribeInstances\n  - name:\
      \ \"CA10__currentRunningTime__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__currentRunningTime__c\"      \n# Nullable.\n  - name: \"CA10__averageCpuTwoWeeks__c\"\
      \n    value: \n      FIELD:\n        path: \"CA10__averageCpuTwoWeeks__c\" \
      \     \n# Nullable.\n  - name: \"CA10__maxCpuTwoWeeks__c\"\n    value: \n  \
      \    FIELD:\n        path: \"CA10__maxCpuTwoWeeks__c\"      \n# Nullable.\n\
      \  - name: \"CA10__sumTwoWeekNetworkOutMb__c\"\n    value: \n      FIELD:\n\
      \        path: \"CA10__sumTwoWeekNetworkOutMb__c\"      \n# Nullable.\n  - name:\
      \ \"CA10__sumTwoWeekNetworkInMb__c\"\n    value: \n      FIELD:\n        path:\
      \ \"CA10__sumTwoWeekNetworkInMb__c\"      \n"
  - path: /ce/ca/aws/ec2/instance-detailed-monitoring/test-data.json
    md5Hash: 9C1FEB9218210F0E89478AE67C505E36
    content: |-
      [
          {
              "expectedResult": {
                  "status": "DISAPPEARED",
                  "conditionIndex": "99",
                  "conditionText": "isDisappeared(CA10__disappearanceTime__c)",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-11-20T19:21:48Z"
              },
              "Id": "test1",
              "CA10__disappearanceTime__c": "2024-11-11T13:22:57Z",
              "CA10__stateName__c": "running",
              "CA10__monitoringState__c": "disabled"
          },
          {
              "expectedResult": {
                  "status": "INAPPLICABLE",
                  "conditionIndex": "199",
                  "conditionText": "extract('CA10__stateName__c') != 'running'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-11-20T19:21:48Z"
              },
              "Id": "test2",
              "CA10__disappearanceTime__c": null,
              "CA10__stateName__c": "stopped",
              "CA10__monitoringState__c": "disabled"
          },
          {
              "expectedResult": {
                  "status": "INCOMPLIANT",
                  "conditionIndex": "299",
                  "conditionText": "extract('CA10__monitoringState__c') == 'disabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-11-20T19:21:48Z"
              },
              "Id": "test3",
              "CA10__disappearanceTime__c": null,
              "CA10__stateName__c": "running",
              "CA10__monitoringState__c": "disabled"
          },
          {
              "expectedResult": {
                  "status": "COMPLIANT",
                  "conditionIndex": "399",
                  "conditionText": "extract('CA10__monitoringState__c') == 'enabled'",
                  "runtimeError": null
              },
              "context": {
                  "snapshotTime": "2024-11-20T19:21:48Z"
              },
              "Id": "test4",
              "CA10__disappearanceTime__c": null,
              "CA10__stateName__c": "running",
              "CA10__monitoringState__c": "enabled"
          }
      ]
script: |-
  CREATE TEMP FUNCTION mock_ExpectedResult()
  RETURNS ARRAY<STRUCT<
          Id STRING,
          expectedResult STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, runtimeError STRING>
      >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "Id" : "test1",
    "expectedResult" : {
      "status" : "DISAPPEARED",
      "conditionIndex" : "99",
      "conditionText" : "isDisappeared(CA10__disappearanceTime__c)",
      "runtimeError" : null
    }
  }, {
    "Id" : "test2",
    "expectedResult" : {
      "status" : "INAPPLICABLE",
      "conditionIndex" : "199",
      "conditionText" : "extract('CA10__stateName__c') != 'running'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test3",
    "expectedResult" : {
      "status" : "INCOMPLIANT",
      "conditionIndex" : "299",
      "conditionText" : "extract('CA10__monitoringState__c') == 'disabled'",
      "runtimeError" : null
    }
  }, {
    "Id" : "test4",
    "expectedResult" : {
      "status" : "COMPLIANT",
      "conditionIndex" : "399",
      "conditionText" : "extract('CA10__monitoringState__c') == 'enabled'",
      "runtimeError" : null
    }
  } ];
  """;

  CREATE TEMP FUNCTION mock_CA10__CaAwsInstance__c()
  RETURNS ARRAY<STRUCT<
      Id STRING,
      CA10__disappearanceTime__c TIMESTAMP,
      CA10__stateName__c STRING,
      CA10__monitoringState__c STRING,
      context STRUCT<
          snapshotTime TIMESTAMP
      >
  >>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
    return [ {
    "context" : {
      "snapshotTime" : new Date("2024-11-20T19:21:48Z")
    },
    "Id" : "test1",
    "CA10__disappearanceTime__c" : new Date("2024-11-11T13:22:57Z"),
    "CA10__stateName__c" : "running",
    "CA10__monitoringState__c" : "disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-11-20T19:21:48Z")
    },
    "Id" : "test2",
    "CA10__stateName__c" : "stopped",
    "CA10__monitoringState__c" : "disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-11-20T19:21:48Z")
    },
    "Id" : "test3",
    "CA10__stateName__c" : "running",
    "CA10__monitoringState__c" : "disabled"
  }, {
    "context" : {
      "snapshotTime" : new Date("2024-11-20T19:21:48Z")
    },
    "Id" : "test4",
    "CA10__stateName__c" : "running",
    "CA10__monitoringState__c" : "enabled"
  } ];
  """;

  CREATE TEMP FUNCTION process_CA10__CaAwsInstance__c(
      obj STRUCT<
          Id STRING,
          CA10__disappearanceTime__c TIMESTAMP,
          CA10__stateName__c STRING,
          CA10__monitoringState__c STRING
      >,
      snapshotTime TIMESTAMP
  )
  RETURNS STRUCT<status STRING, conditionIndex DECIMAL, conditionText STRING, currentStateMessage STRING, currentStateReferences STRING, remediation STRING, runtimeError STRING>
  DETERMINISTIC
  LANGUAGE js
  AS r"""
      var TextLib = new function () {
          this.normalize = function(arg) {
              return arg == null ? '' : arg.replace(/\s+/g, ' ').trim().toLowerCase();
          };
          this.isEmpty = function(arg) {
              return this.normalize(arg) == '';
          };
          this.isNotEmpty = function(arg) {
              return this.normalize(arg) != '';
          };
          this.equal = function(left, right) {
              return this.normalize(left) == this.normalize(right);
          };
          this.notEqual = function(left, right) {
              return this.normalize(left) != this.normalize(right);
          };
          this.startsWith = function(arg, substring) {
              return this.normalize(arg).startsWith(this.normalize(substring));
          };
          this.endsWith = function(arg, substring) {
              return this.normalize(arg).endsWith(this.normalize(substring));
          };
          this.contains = function(arg, substring) {
              return this.normalize(arg).includes(this.normalize(substring));
          };
      }();
      var references1 = [];
      // condition[0], conditionIndex:[0..99]
      references1.push('Deleted From AWS [CA10__disappearanceTime__c]: ' + obj.CA10__disappearanceTime__c);
      if (obj.CA10__disappearanceTime__c != null) {
          return {status: 'DISAPPEARED', conditionIndex: 99, conditionText: "isDisappeared(CA10__disappearanceTime__c)", currentStateMessage: "Object is deleted in the source", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
      }
      // condition[1], conditionIndex:[100..199]
      function fieldChecked4() {
          if (TextLib.isEmpty(obj.CA10__stateName__c)) {
              throw new Error("UNDETERMINED condition:101", {cause: {status: 'UNDETERMINED', conditionIndex: 101, conditionText: "CA10__stateName__c.delegatedTo(CA10__stateName__c).isEmpty()", currentStateMessage: "Unable to determine EC2 Instances State Name. Possible permission issue with ec2:DescribeInstanceStatus", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__stateName__c;
      }
      function extract3() { if (!this.out) { this.out = fieldChecked4(); } return this.out; };
      references1.push('State Name [obj.CA10__stateName__c]: ' + obj.CA10__stateName__c);
      try {
          if (TextLib.notEqual(extract3.call(extract3), 'running')) {
              return {status: 'INAPPLICABLE', conditionIndex: 199, conditionText: "extract('CA10__stateName__c') != 'running'", currentStateMessage: "The EC2 instance is not running.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[2], conditionIndex:[200..299]
      function fieldChecked7() {
          if (TextLib.isEmpty(obj.CA10__monitoringState__c)) {
              throw new Error("UNDETERMINED condition:201", {cause: {status: 'UNDETERMINED', conditionIndex: 201, conditionText: "CA10__monitoringState__c.isEmpty()", currentStateMessage: "Corrupted data. EC2 Instances Detailed Monitoring State cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__monitoringState__c;
      }
      function extract6() { if (!this.out) { this.out = fieldChecked7(); } return this.out; };
      references1.push('Monitoring State [obj.CA10__monitoringState__c]: ' + obj.CA10__monitoringState__c);
      try {
          if (TextLib.equal(extract6.call(extract6), 'disabled')) {
              return {status: 'INCOMPLIANT', conditionIndex: 299, conditionText: "extract('CA10__monitoringState__c') == 'disabled'", currentStateMessage: "The instance is running without detailed monitoring enabled.", currentStateReferences: references1.join('\n'), remediation: "Consider enabling detailed monitoring for the instance.", runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      // condition[3], conditionIndex:[300..399]
      function fieldChecked10() {
          if (TextLib.isEmpty(obj.CA10__monitoringState__c)) {
              throw new Error("UNDETERMINED condition:301", {cause: {status: 'UNDETERMINED', conditionIndex: 301, conditionText: "CA10__monitoringState__c.isEmpty()", currentStateMessage: "Corrupted data. EC2 Instances Detailed Monitoring State cannot be empty.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null}});
          }
          return obj.CA10__monitoringState__c;
      }
      function extract9() { if (!this.out) { this.out = fieldChecked10(); } return this.out; };
      try {
          if (TextLib.equal(extract9.call(extract9), 'enabled')) {
              return {status: 'COMPLIANT', conditionIndex: 399, conditionText: "extract('CA10__monitoringState__c') == 'enabled'", currentStateMessage: "Detailed monitoring for the instance is enabled.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
          }
      } catch (err) {
          if (err.cause && err.cause.status) { return err.cause; } else { throw err; }
      }
      return {status: 'UNDETERMINED', conditionIndex: 400, conditionText: "otherwise", currentStateMessage: "Unexpected values in the field.", currentStateReferences: references1.join('\n'), remediation: null, runtimeError: null};
  """;


  SELECT
    expectedResult.Id as Id,
    IF (
      IFNULL(expectedResult.expectedResult.status, '') = IFNULL(sObject.result.status, '')
      AND IFNULL(expectedResult.expectedResult.conditionIndex, -1) = IFNULL(sObject.result.conditionIndex, -1)
      AND IFNULL(expectedResult.expectedResult.conditionText, '') = IFNULL(sObject.result.conditionText, '')
      AND IFNULL(expectedResult.expectedResult.runtimeError, '') = IFNULL(sObject.result.runtimeError, ''),
      "MATCH",
      "FAIL"
    ) as match,
    expectedResult.expectedResult.status as expectedStatus, sObject.result.status as actualStatus,
    expectedResult.expectedResult.conditionIndex as expectedConditionIndex, sObject.result.conditionIndex as actualConditionIndex,
    expectedResult.expectedResult.conditionText as expectedConditionText, sObject.result.conditionText as actualConditionText,
    expectedResult.expectedResult.runtimeError as expectedRuntimeError, sObject.result.runtimeError as actualRuntimeError
  FROM UNNEST(mock_ExpectedResult()) expectedResult
  LEFT JOIN (
      SELECT
          sObject.Id AS Id,
          sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
          sObject.CA10__stateName__c AS CA10__stateName__c,
          sObject.CA10__monitoringState__c AS CA10__monitoringState__c,
          process_CA10__CaAwsInstance__c(
              STRUCT(
                  sObject.Id AS Id,
                  sObject.CA10__disappearanceTime__c AS CA10__disappearanceTime__c,
                  sObject.CA10__stateName__c AS CA10__stateName__c,
                  sObject.CA10__monitoringState__c AS CA10__monitoringState__c
              ),
              sObject.context.snapshotTime
          ) as result
      FROM UNNEST(mock_CA10__CaAwsInstance__c()) AS sObject
  ) sObject ON sObject.Id = expectedResult.Id;
